
Smart Proxy - Bug #1654

Failed to list puppet environments: hash modified during iteration

05/28/2012 06:01 AM - Florent Castelli

Status: Closed   

Priority: Normal   

Assignee: Florent Castelli   

Category: Puppet   

Target version: 1.0   

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

Happens when trying to import environments and classes from foreman git using smart-proxy git.

Probably because of lib/proxy/puppet/environment.rb:59 "env.delete(environment)"

E, [2012-05-28T09:42:51.699475 #3577] ERROR -- : Failed to list puppet environments: hash modified during iteration

/home/orphis/smart-proxy/bin/../lib/proxy/puppet/environment.rb:45:in `each'

/home/orphis/smart-proxy/bin/../lib/proxy/puppet/environment.rb:45:in `puppet_environments'

/home/orphis/smart-proxy/bin/../lib/proxy/puppet/environment.rb:11:in `all'

/home/orphis/smart-proxy/bin/../lib/puppet_api.rb:15:in `GET /puppet/environments'

/usr/lib/ruby/1.8/sinatra/base.rb:863:in `call'

/usr/lib/ruby/1.8/sinatra/base.rb:863:in `route'

/usr/lib/ruby/1.8/sinatra/base.rb:521:in `instance_eval'

/usr/lib/ruby/1.8/sinatra/base.rb:521:in `route_eval'

/usr/lib/ruby/1.8/sinatra/base.rb:500:in `route!'

/usr/lib/ruby/1.8/sinatra/base.rb:497:in `catch'

/usr/lib/ruby/1.8/sinatra/base.rb:497:in `route!'

/usr/lib/ruby/1.8/sinatra/base.rb:476:in `each'

/usr/lib/ruby/1.8/sinatra/base.rb:476:in `route!'

/usr/lib/ruby/1.8/sinatra/base.rb:601:in `dispatch!'

/usr/lib/ruby/1.8/sinatra/base.rb:411:in `call!'

/usr/lib/ruby/1.8/sinatra/base.rb:566:in `instance_eval'

/usr/lib/ruby/1.8/sinatra/base.rb:566:in `invoke'

/usr/lib/ruby/1.8/sinatra/base.rb:566:in `catch'

/usr/lib/ruby/1.8/sinatra/base.rb:566:in `invoke'

/usr/lib/ruby/1.8/sinatra/base.rb:411:in `call!'

/usr/lib/ruby/1.8/sinatra/base.rb:399:in `call'

/usr/lib/ruby/1.8/rack/showexceptions.rb:24:in `call'

/usr/lib/ruby/1.8/rack/commonlogger.rb:18:in `call'

/usr/lib/ruby/1.8/sinatra/base.rb:979:in `call'

/usr/lib/ruby/1.8/sinatra/base.rb:1005:in `synchronize'

/usr/lib/ruby/1.8/sinatra/base.rb:979:in `call'

/usr/lib/ruby/1.8/rack/content_length.rb:13:in `call'

/usr/lib/ruby/1.8/rack/handler/webrick.rb:48:in `service'

/usr/lib/ruby/1.8/webrick/httpserver.rb:104:in `service'

/usr/lib/ruby/1.8/webrick/httpserver.rb:65:in `run'

/usr/lib/ruby/1.8/webrick/server.rb:173:in `start_thread'

/usr/lib/ruby/1.8/webrick/server.rb:162:in `start'

/usr/lib/ruby/1.8/webrick/server.rb:162:in `start_thread'

/usr/lib/ruby/1.8/webrick/server.rb:95:in `start'

/usr/lib/ruby/1.8/webrick/server.rb:92:in `each'

/usr/lib/ruby/1.8/webrick/server.rb:92:in `start'

/usr/lib/ruby/1.8/webrick/server.rb:23:in `start'

/usr/lib/ruby/1.8/webrick/server.rb:82:in `start'

/usr/lib/ruby/1.8/rack/handler/webrick.rb:14:in `run'

/home/orphis/smart-proxy/bin/../lib/sinatra-patch.rb:36:in `run!'

/home/orphis/smart-proxy/bin/smart-proxy:102
https://projects.theforeman.org/issues/3577


Associated revisions

Revision d54d0686 - 06/06/2012 07:36 AM - Florent Castelli

Don't modify the hash we are iterating on when listing environments fixes #1654

History

#1 - 06/06/2012 07:37 AM - Ohad Levy

- Category set to Puppet

- Target version set to 1.0

#2 - 06/06/2012 07:38 AM - Ohad Levy

- Assignee set to Florent Castelli

#3 - 06/06/2012 11:53 AM - Florent Castelli

- Status changed from New to Closed

- % Done changed from 0 to 100

Applied in changeset d54d06863ed6f91ff32e7aac09eed6eec95cbd1c.
